(function() {
  var Mixpanel, request;

  request = require('request');

  exports.Mixpanel = Mixpanel = (function() {

    Mixpanel.prototype.request = request;

    Mixpanel.prototype.server = 'http://api.mixpanel.com';

    Mixpanel.prototype.alias = true;

    Mixpanel.prototype.autoTime = false;

    function Mixpanel(options) {
      this.token = options.token;
      if (options.request != null) this.request = options.request;
      if (options.endpoint != null) this.endpoint = options.endpoint;
      if (options.ip != null) this.ip = !!options.ip;
      if (options.test != null) this.test = !!options.test;
      if (options.alias != null) this.alias = !!options.alias;
      if (options.autoNow != null) this.autoNow = !!options.autoNow;
    }

    Mixpanel.prototype.track = function(event) {
      var args, callback, data, options, properties, query, setIp, setTime, test, uri, _ref, _ref2, _ref3;
      args = Array.prototype.slice.call(arguments, 1);
      if (typeof args[args.length - 1] === 'function') callback = args.pop();
      properties = args.shift() || {};
      options = args[0] || {};
      setIp = options.ip != null ? options.ip : this.ip;
      setTime = options.autoNow != null ? options.autoNow : this.autoNow;
      test = options.test != null ? options.test : this.test;
      properties.token = this.token;
      if (setTime) {
        properties.time = parseInt(Date.now() / 1000);
      } else if ((_ref = properties.time) != null ? _ref.getTime : void 0) {
        properties.time = parseInt(properties.time.getTime() / 1000);
      }
      if (this.alias) {
        if (properties.id != null) {
          if ((_ref2 = properties.distinct_id) == null) {
            properties.distinct_id = properties.id;
          }
          delete properties.id;
        }
        if (properties.tag != null) {
          if ((_ref3 = properties.mp_name_tag) == null) {
            properties.mp_name_tag = properties.tag;
          }
          delete properties.tag;
        }
      }
      if (setIp) delete properties.ip;
      data = {
        event: event,
        properties: properties
      };
      data = new Buffer(JSON.stringify(data)).toString('base64');
      query = ['data=' + data];
      if (setIp) query.push('ip=1');
      if (test) query.push('test=1');
      query = query.join('&');
      uri = this.server + '/track?' + query;
      if (callback) {
        return this.request(uri, function(err, res, body) {
          if (err) return callback(err);
          return callback(null, body === '1');
        });
      } else {
        return this.request(uri);
      }
    };

    return Mixpanel;

  })();

}).call(this);
